/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _handleball
#define _handleball

#include "command.h"
#include "geometry.h" 
#include "shoot.h"
#include "interception.h"
#include "objects.h"
#include "pass.h"


class Handleball{
private:
	Time startime, action_times;
	ActionType lastaction;
	bool handleable;

	/* inner-module competition
	the result is saved in log***	*/
	bool DoShootDecision();
	bool DoDribbleDecision();
	bool DoPassDecision();
	/* inter-module competition */
	void Evaluate();

//sensitivity grad info

	bool passable;
	bool dribblable;
	bool shootable;
	float pass_priority;
	float dribble_priority;
	float shoot_priority;
	Command shootcommand;

public:
	bool Handlable();
	bool Tryhandle();
	void B_evaluate();
	bool DoHandleballDecision();

	PassInfo logpass;
	float logdribble;
	ShootInfo logshoot;

	float GetShootPriority(ShootInfo& shoot);
	float GetDribblePriority(AngleDeg angle);
	float GetPassPriority(PassInfo& passinfo);
	
	float GetMinShootSpeed(){ return logshoot.MinShootSpeed();}
	AngleDeg GetShootAngle(){ return logshoot.ShootAngle();}
	UNum GetReceiver(){ return logpass.Receiver();}
	float GetPassSpeed(){ return logpass.PassSpeed();}
	AngleDeg GetPassAngle(){ return logpass.PassAngle();}
	AngleDeg GetDribbleAngle(){ return logdribble;}

	bool WaitPassLook();
};
#endif