/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _LogUnit
#define _LogUnit
#include "types.h"
#include "stdafx.h"
#include "stdio.h"
#include "netif.h"

class Log{
protected:
	bool LogOn[32];
	char logstring[2 * MAXMESG];
	char header[100];
	char logbuffer[5 * MAXMESG];
	int logbuffer_len;
	char label[32][16];
	char logfilename[100];
	SECURITY_ATTRIBUTES sa;
	HANDLE hFile;
	FILE* fp;
	int  logcount;
	int maxlogcount;
	bool filenameset;
	bool LogLocked;
	int LogCounts;
public:
	Log(int maxlogcount = 10000000);
	~Log();

	void AssociateFile(char* filename);
	void SetLogOn(int lognum);
	void SetLogOff(int lognum);
	void SetLabel(int lognum, char* caption);
	void LogAction(int lognum,char*,...);
	void LogAction(char*,...);
	virtual void LogCore(int lognum,char*);
	virtual bool CanLog(int lognum);
};


class LogData : public Log{
public:
	void LogCore(int lognum, char *);
};
#endif