/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#include "stopwatch.h"
#include "global.h"
/*******Stopwatch*****************/
Stopwatch::Stopwatch(){
	LARGE_INTEGER frq;
	QueryPerformanceFrequency(&frq);
	frequency = frq.QuadPart;
	current_cycle = 0;
}

void Stopwatch::QueryTime(TimedDataArray<LARGE_INTEGER, NUMSTOPWATCHS>& t, int cycle){
	LARGE_INTEGER tmp;
	QueryPerformanceCounter(&tmp);
	t.Setdata(tmp, cycle);
}

float Stopwatch::TimeElapsedThisCycle(){
	LARGE_INTEGER tmp;
	QueryPerformanceCounter(&tmp);
	return MsBetween(Cycle_s.Data(current_cycle), tmp);
}

float Stopwatch::TimeElapsedAfterAIStart(){
	LARGE_INTEGER tmp;
	QueryPerformanceCounter(&tmp);
	return MsBetween(AI_s.Data(current_cycle), tmp);
}

float Stopwatch::SightIntervalBetween(int prevcycle, int nextcycle){
	return MsBetween(See_t.Data(prevcycle), See_t.Data(nextcycle));
}

float Stopwatch::TimeElapsedSight(){
	LARGE_INTEGER tmp;
	QueryPerformanceCounter(&tmp);
	return Min(MsBetween(See_t.Data(sensory.LastSightTime), tmp), MsBetween(Changeview_t, tmp));
}

float Stopwatch::PredictNextSight(){
	float timelapsed = Min(MsBetween(See_t.Data(sensory.LastSightTime), Cycle_s.Data(current_cycle)), MsBetween(Changeview_t, Cycle_s.Data(current_cycle)));
	float sightgap = (float)sensory.MySightInterval(); 
	return sightgap - timelapsed;
} 