/* Tsinghuaeolus soccer client for Robocup2001
 *
 * Computer Science Department
 * State Key Lab of Intelligent Technology and Systems
 * Tsinghua University
 * 
 * Copyright (C) 2001 Tsinghuaeolus
 * Team Leader : Lishi
 * Team memebers : ChenJiang, YaoJinyi, CaiYunpeng
 *
 * We thank CMU for CMU98 was used for reference in our initial stage.
 *
 * You may copy and distribute this program freely as long as you retain this notice.
 * If you make any changes or have any comments we would appreciate a message to yjy01@mails.tsinghua.edu.cn.
 * For more information, please see http://www.lits.tsinghua.edu.cn/RoboCup
 */

#ifndef _positioning
#define _positioning
#include "bpn.h"
#include "types.h"
#include "Command.h"
#include "Strategy.h"
#include "df_positioning.h"

class PositionAction{
protected:
	Vector point;
	float  rapidness;
	float max_deviation;
	float priority;
	ActionType actiontype;
public:
	PositionAction();
	float GetPriority();
	ActionType GetActionType(){ return actiontype;};
	void SetPositioningInfo(Vector point, float rapidness, float max_deviation, float priority, ActionType actiontype);
	void position();
};

class Positioning : public DF_positioning, public PositionAction{
private:
public:
	TimedDataArray<DF_Arrangement, 3> logdefense;

	Positioning();
	
	void Position();
	void Defense();
	void Offense();
	void OffensiveFormation();
	void DefensiveFormation();
	float GetDefenseSpeed(const DF_Arrangement & arrangement);
	void CloseBlock(DF_Arrangement &arrangement);
};
#endif